<div align="center">
    <h1>SimpleModDownloader</h1>
    <p>A switch homebrew which downloads mods from gamebanana</p>
</div>

<p align="center">
    <a rel="LICENSE" href="https://github.com/PoloNX/SimpleModDownloader/blob/master/LICENSE">
        <img src="https://img.shields.io/static/v1?label=license&message=GPLV3&labelColor=111111&color=0057da&style=for-the-badge&logo=data%3Aimage/png%3Bbase64%2CiVBORw0KGgoAAAANSUhEUgAAABQAAAATCAYAAACQjC21AAAACXBIWXMAAAsTAAALEwEAmpwYAAAAIGNIUk0AAHpFAACAgwAA/FcAAIDoAAB5FgAA8QEAADtfAAAcheDStWoAAAFGSURBVHjarJK9LgRhFIafWUuiEH/rJwrJClEq3IELUKgo3IrETWh0FC7BNVih0AoKBQoEydq11qMwm5yMsbPEm3yZd55zvnfO92VQKVhLak09UZeL%2BrsVZ9Qdv2tXnf1NYEndUushZFGthvemuq32FwWuq%2BeZid5DvZGpXambeYGr6qnd9dGldqaudQL3QuFWvVbbmaC6%2BprDr9WbwA4SdQW4BwaABb50CTykfjjwC%2BAx9SPAfOANYDxRCXpOnxNAM4ePA63Ul8NHR4E2QClsGgGG0jUR%2BFjglcAn8/pj4HTwUz/42FPJ68lOSDhCkR/O46XM0Qh3VcRH83jph%2BZefKUosBr8XA%2B%2BmufLAR4Dh6k/CrzWA691YOc/3Ejv6iNM3k59Xw%2B8D3gC9hN1ErjjfzSbqHVg8J8CG2XgBXgL4/9VCdD6HACaHdcHGCRMgQAAAABJRU5ErkJggg%3D%3D" alt=License>
    </a>
    <a rel="VERSION" href="https://github.com/PoloNX/AtmoPackUpdater">
        <img src="https://img.shields.io/static/v1?label=version&message=1.1.0&labelColor=111111&color=06f&style=for-the-badge" alt="Version">
    </a>
    <a rel="BUILD" href="https://github.com/PoloNX/SimpleModDownloader/actions">
        <img src="https://img.shields.io/github/actions/workflow/status/PoloNX/AtmoPackUpdater/c-cpp.yml?branch=master &labelColor=111111&color=06f&style=for-the-badge" alt=Build>
    </a>
</p>

---
  
     

- [Features](#features)
- [Screenshot](#screenshot)
- [How to build](#how-to-build)
- [Help me](#help-me)
- [Credits](#credits)

## Features

- Download mods from gamebanana directly from your switch
- Install mods directly from your switch with [SimpleModManager](https://github.com/nadrino/SimpleModManager)

## Screenshot

![](./screenshots/1.jpg)

<details>
  <summary><b>More Screenshots</b></summary>

![](./screenshots/2.jpg)
![](./screenshots/3.jpg)
![](./screenshots/4.jpg)
![](./screenshots/5.jpg)
![](./screenshots/6.jpg)

</details>

## How to build

### Requirements

- [devkitPro](https://devkitpro.org/wiki/Getting_Started)
- [CMake](https://cmake.org/download/)
- [Ninja](https://ninja-build.org/)
- [Docker](https://www.docker.com/) (Windows only)

If you don't want to use docker on windows you can use [MSYS2](https://www.msys2.org/) to build the app.

### Linux

```bash
sudo pacman -S switch-curl switch-zlib switch-glfw switch-mesa switch-glm switch-libarchive  
git clone --recursive https://github.com/PoloNX/SimpleModDownloader/
cd SimpleModDownloader
cmake -B cmake-build-switch -G Ninja -DPLATFORM_SWITCH=ON -DCMAKE_BUILD_TYPE=Debug
cmake --build cmake-build-switch --target SimpleModDownloader.nro
```

### Windows

```bash
pacman -S switch-curl switch-zlib switch-glfw switch-mesa switch-glm switch-libarchive  
git clone --recursive https://github.com/PoloNX/SimpleModDownloader/
cd SimpleModDownloader
docker run --rm -v ${PWD}:/data devkitpro/devkita64:latest `
bash -c "cd /data ; cmake -B cmake-build-switch -G Ninja -DPLATFORM_SWITCH=ON -DCMAKE_BUILD_TYPE=Debug ; cmake --build cmake-build-switch --target SimpleModDownloader.nro"
```

## Help me

If you want to help me open an issue when you encounter a bug and a pull request if you have a fix.

## Credits 

- Thanks to [Natinusala](https://github.com/natinusala), [xfangfang](https://github.com/xfangfang) and [XITRIX](https://github.com/XITRIX) for [borealis](https://github.com/xfangfang/borealis)
- Thanks to [nadrino](https://github.com/nadrino) for [SimpleModManager](https://github.com/nadrino/SimpleModManager)
- Thanks to [GameBanana](https://gamebanana.com/) for their API
- Thanks to [Pikatsuto](https://github.com/Pikatsuto) for the logo and SuperButterScotch for the typo
- Thanks to [NicholeMattera](https://github.com/NicholeMattera) for [Simple-INI-Parser](https://github.com/NicholeMattera/Simple-INI-Parser)
- Special thanks to [xfangfang](https://github.com/xfangfang) for helping me with all the UI stuff

- Thanks to [JerryWn12](https://github.com/JerryWn12) for chinese translation
- Thanks to [iGlitch](https://github.com/iGlitch)for japanese translation
- Thanks to [ExFabian](https://github.com/ExFabian) for romanian translation
- Thanks to [spkats1](https://github.com/spkats1) and [tsamerman](https://github.com/tsamerman) for greek translation
- Thanks to [pixeldeadlock](https://github.com/pixeldeadlock) for brazilian portuguese translation
- Thanks to [garobcsi](https://github.com/garobcsi) for hungarian translation


